#!/bin/sh
#
# Georg Holzmann, 2007
#
# average test data

CMD=average_data/average_data

average_datapoints()
{
  for TYPE in sparse nonsparse ; do
  for PREC in float double ; do
  for CONN in 0.05 0.1 0.2 0.4 ; do
    $CMD $1_${TYPE}_${PREC}-conn${CONN}-avg.dat $1_${TYPE}_${PREC}-conn${CONN}-1.dat $1_${TYPE}_${PREC}-conn${CONN}-2.dat $1_${TYPE}_${PREC}-conn${CONN}-3.dat $1_${TYPE}_${PREC}-conn${CONN}-4.dat $1_${TYPE}_${PREC}-conn${CONN}-5.dat $1_${TYPE}_${PREC}-conn${CONN}-6.dat
  done
  done
  done
}

average_datapoints_nonsparse()
{
  TYPE=nonsparse
  for PREC in float double ; do
  for CONN in 0.05 0.1 0.2 0.4 ; do
    $CMD $1_${TYPE}_${PREC}-conn${CONN}-avg.dat $1_${TYPE}_${PREC}-conn${CONN}-1.dat $1_${TYPE}_${PREC}-conn${CONN}-2.dat $1_${TYPE}_${PREC}-conn${CONN}-3.dat $1_${TYPE}_${PREC}-conn${CONN}-4.dat $1_${TYPE}_${PREC}-conn${CONN}-5.dat $1_${TYPE}_${PREC}-conn${CONN}-6.dat
  done
  done
}

average_datapoints_nonsparse_double()
{
  TYPE=nonsparse
  PREC=double
  for CONN in 0.05 0.1 0.2 0.4 ; do
    $CMD $1_${TYPE}_${PREC}-conn${CONN}-avg.dat $1_${TYPE}_${PREC}-conn${CONN}-1.dat $1_${TYPE}_${PREC}-conn${CONN}-2.dat $1_${TYPE}_${PREC}-conn${CONN}-3.dat $1_${TYPE}_${PREC}-conn${CONN}-4.dat $1_${TYPE}_${PREC}-conn${CONN}-5.dat $1_${TYPE}_${PREC}-conn${CONN}-6.dat
  done
}

FILE=blitz++/blitz
average_datapoints_nonsparse $FILE

FILE="boost-ublas/boost"
average_datapoints $FILE

FILE="flens/flens"
average_datapoints $FILE

FILE="gmm++/gmm"
average_datapoints $FILE

FILE="mtl/mtl"
average_datapoints $FILE

FILE="newmat/newmat"
average_datapoints_nonsparse_double $FILE
