#define WANT_STREAM
#define WANT_MATH

#include "newmatap.h"
#include "newmatio.h" 

using namespace NEWMAT;
using namespace std;

#include "../bench-tools.h"

Matrix *W;
ColumnVector *in;
ColumnVector *back;
RowVector *out;
ColumnVector *x;

int main(int argc, char *argv[])
{
  run_benchmarks(argc,argv);
}

void init_matrices()
{
  W = new Matrix(N,N);
  in = new ColumnVector(N);
  back = new ColumnVector(N);
  out = new RowVector(2*N);
  x = new ColumnVector(N);

  for (int i=1; i<=N; ++i)
  {
    if(randval()<i_conn) (*in)(i) = randval();
    if(randval()<fb_conn) (*back)(i) = randval();
    (*x)(i) = randval();

    for (int j=1; j<=N; ++j)
    {
      if(randval()<conn) (*W)(i,j) = randval();
    }
  }

  for (int i=1; i<=2*N; ++i)
    (*out)(i) = randval();
}

double compute(int iter)
{
  ColumnVector t(2*N);

  while(iter--)
  {
    *x = *W * *x;
    *x += alpha * *in;
    *x += beta * *back;

    // activation function
   for(int i=1; i<=N; ++i)
     (*x)(i) = tanh( (*x)(i) );

   // make a temporary vector (x,x^2)
   t = *x & *x;
   for(int i=1; i<=N; ++i)
     t(N+i) = pow((*x)(i),2);

   // compute output
   y = DotProduct(*out, t);
  }

  return y;
}

void mtx_vec_mult(int iter)
{
  while(iter--)
  {
    // STRANGE: this does not work:
    // x = W * x;
    // it takes really a lot cpu
    // (but in compute() this works fast !?)
    // so for the test now this:
    *in = *W * *x;
  }
}
