#!/bin/sh
#
# Georg Holzmann, 2007
#
# runs all benchmarks for all libs
#
# ATTENTION: this might take a some hours !


echo "------------------------"
echo " starting benchmarks ..."
echo "------------------------"

for VERS in 1 2 3 4 5 6 ; do
for CONN in 0.05 0.1 0.2 0.4 ; do

echo "\n-------- blitz++ --------"
./run_benchmark.sh blitz++/blitz_nonsparse_double $VERS $CONN
./run_benchmark.sh blitz++/blitz_nonsparse_float $VERS $CONN

echo "\n-------- boost --------"
./run_benchmark.sh boost-ublas/boost_nonsparse_double $VERS $CONN
./run_benchmark.sh boost-ublas/boost_nonsparse_float $VERS $CONN
./run_benchmark.sh boost-ublas/boost_sparse_double $VERS $CONN
./run_benchmark.sh boost-ublas/boost_sparse_float $VERS $CONN

echo "\n-------- flens --------"
./run_benchmark.sh flens/flens_nonsparse_double $VERS $CONN
./run_benchmark.sh flens/flens_nonsparse_float $VERS $CONN
./run_benchmark.sh flens/flens_sparse_double $VERS $CONN
./run_benchmark.sh flens/flens_sparse_float $VERS $CONN

echo "\n-------- gmm++ --------"
./run_benchmark.sh gmm++/gmm_nonsparse_double $VERS $CONN
./run_benchmark.sh gmm++/gmm_nonsparse_float $VERS $CONN
./run_benchmark.sh gmm++/gmm_sparse_double $VERS $CONN
./run_benchmark.sh gmm++/gmm_sparse_float $VERS $CONN

echo "\n-------- mtl --------"
./run_benchmark.sh mtl/mtl_nonsparse_double $VERS $CONN
./run_benchmark.sh mtl/mtl_nonsparse_float $VERS $CONN
./run_benchmark.sh mtl/mtl_sparse_double $VERS $CONN
./run_benchmark.sh mtl/mtl_sparse_float $VERS $CONN

echo "\n-------- newmat --------"
./run_benchmark.sh newmat/newmat_nonsparse_double $VERS $CONN

done
done

echo "\n------------------------"
echo "... benchmarks finished"
echo "------------------------"
